> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Incoming Call

> Incoming Call — CometChat documentation.

## Overview

The `Incoming call` is a [Component](/ui-kit/react/v4/components-overview#components) that serves as a visual representation when the user receives an incoming call, such as a voice call or video call, providing options to answer or decline the call.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_oiGBuX1qG3S8Eo5/images/60c4a77c-incoming_calls_overview_web_screens-d88b7ba55048b0223256329a84362b46.png?fit=max&auto=format&n=_oiGBuX1qG3S8Eo5&q=85&s=e67a3c610f888d78561d0220f3360016" width="3600" height="2400" data-path="images/60c4a77c-incoming_calls_overview_web_screens-d88b7ba55048b0223256329a84362b46.png" />
</Frame>

The `Incoming Call` is comprised of the following base components:

| Components                                        | Description                                                                                                                                    |
| ------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------- |
| [cometchat-list-item](/ui-kit/react/v4/list-item) | This component’s view consists of avatar, status indicator , title, and subtitle. The fields are then mapped with the SDK’s user, group class. |
| [cometchat-icon](/ui-kit/react/v4/icon)           | This component displays an icon. It currently supports only svg icons                                                                          |
| [cometchat-label](/ui-kit/react/v4/label)         | This component provides descriptive information about the associated UI element.                                                               |
| cometchat-button                                  | This component represents a button with optional icon and text.                                                                                |
| [cometchat-avatar](/ui-kit/react/v4/avatar)       | This component component displays an image or user's avatar with fallback to the first two letters of the username                             |

## Usage

### Integration

<Tabs>
  <Tab title="IncomingCallsDemo.tsx">
    ```typescript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      return <CometChatIncomingCall />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import { IncomingCallsDemo } from "./IncomingCallsDemo";

    export default function App() {
      return (
        <div className="App">
          <div>
            <IncomingCallsDemo />
          </div>
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

#### 1. onAccept

`onAccept` is triggered when you click the accept button of the `Incoming Call` component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const handleOnAccept = () => {
        console.log("custom on accept action");
      };

      return <CometChatIncomingCall onAccept={handleOnAccept} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const handleOnAccept = () => {
        console.log("custom on accept action");
      };

      return <CometChatIncomingCall onAccept={handleOnAccept} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

#### 2. onDecline

`onDecline` is triggered when you click the Decline button of the `Incoming Call` component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const handleOnDecline = () => {
        console.log("your custom on decline action");
      };

      return <CometChatIncomingCall onDecline={handleOnDecline} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const handleOnDecline = () => {
        console.log("your custom on decline action");
      };

      return <CometChatIncomingCall onDecline={handleOnDecline} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

#### 3. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Incoming Call component.

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const handleOnError = () => {
        console.log("your custom on error action");
      };

      return <CometChatIncomingCall onError={handleOnError} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const handleOnError = () => {
        console.log("your custom on error action");
      };

      return <CometChatIncomingCall onError={handleOnError} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a `Component`. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using `RequestBuilders` of Chat SDK.

The `Incoming Call` component does not have any exposed filters.

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The list of events emitted by the Incoming Call component is as follows.

| Event              | Description                                                                  |
| ------------------ | ---------------------------------------------------------------------------- |
| **ccCallRejected** | This event is triggered when the initiated call is rejected by the receiver. |
| **ccCallAccepted** | This event is triggered when the initiated call is accepted by the receiver. |
| **ccCallEnded**    | This event is triggered when the initiated call successfully ends.           |

<Tabs>
  <Tab title="Add Listener">
    ```javascript theme={null}
    const ccCallRejected = CometChatCallEvents.ccCallRejected.subscribe(
      (call: CometChat.Call) => {
        //Your Code
      }
    );

    const ccCallAccepted = CometChatCallEvents.ccCallAccepted.subscribe(
      (call: CometChat.Call) => {
        //Your Code
      }
    );

    const ccCallEnded = CometChatCallEvents.ccCallEnded.subscribe(
      (call: CometChat.Call) => {
        //Your Code
      }
    );
    ```
  </Tab>
</Tabs>

***

<Tabs>
  <Tab title="Remove Listener">
    ```javascript theme={null}
    ccCallRejected?.unsubscribe();

    ccCallAccepted?.unsubscribe();

    ccCallEnded?.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Incoming Call component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using Style you can customize the look and feel of the component in your app, These parameters typically control elements such as the color, size, shape, and fonts used within the component.

#### 1. IncomingCall Style

To customize the appearance, you can assign a `IncomingCallStyle` object to the `Incoming Call` component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/79131f41-incoming_calls_style_web_screens-11162dbf1c429ce2670be368246496b2.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=7e1f6c85851839018e2bb6d8c8a39f6f" width="3600" height="2400" data-path="images/79131f41-incoming_calls_style_web_screens-11162dbf1c429ce2670be368246496b2.png" />
</Frame>

**Example**

In this example, we are employing the `IncomingCallStyle`.

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import {
      CometChatIncomingCall,
      IncomingCallStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const incomingCallStyle = new IncomingCallStyle({
        acceptButtonBackground: "#7b49de",
        acceptButtonTextColor: "#ffffff",
        background: "#8761d4",
        declineButtonBackground: "#4b08d1",
      });

      return <CometChatIncomingCall incomingCallStyle={incomingCallStyle} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import {
      CometChatIncomingCall,
      IncomingCallStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const incomingCallStyle = new IncomingCallStyle({
        acceptButtonBackground: "#7b49de",
        acceptButtonTextColor: "#ffffff",
        background: "#8761d4",
        declineButtonBackground: "#4b08d1",
      });

      return <CometChatIncomingCall incomingCallStyle={incomingCallStyle} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

The following properties are exposed by IncomingCallStyle:

| Property                      | Description                                 | Code                                  |
| ----------------------------- | ------------------------------------------- | ------------------------------------- |
| **border**                    | Used to set border                          | `border?: string,`                    |
| **borderRadius**              | Used to set border radius                   | `borderRadius?: string;`              |
| **background**                | Used to set background colour               | `background?: string;`                |
| **height**                    | Used to set height                          | `height?: string;`                    |
| **width**                     | Used to set width                           | `width?: string;`                     |
| **titleTextFont**             | Used to set title text font                 | `titleTextFont?: string,`             |
| **titleTextColor**            | Used to set title text color                | `titleTextColor?: string;`            |
| **subtitleTextFont**          | Used to set subtitle text font              | `subtitleTextFont?: string;`          |
| **subtitleTextColor**         | Used to set subtitle text color             | `subtitleTextColor?: string;`         |
| **acceptButtonTextFont**      | Used to set accept button text font         | `acceptButtonTextFont?: string;`      |
| **acceptButtonTextColor**     | Used to set accept button text color        | `acceptButtonTextColor?: string;`     |
| **acceptButtonBackground**    | Used to set accept button background color  | `acceptButtonBackground?: string;`    |
| **acceptButtonBorderRadius**  | Used to set accept button border radius     | `acceptButtonBorderRadius?: string;`  |
| **acceptButtonBorder**        | Used to set accept button border            | `acceptButtonBorder?: string;`        |
| **declineButtonTextFont**     | Used to set decline button text font        | `declineButtonTextFont?: string;`     |
| **declineButtonTextColor**    | Used to set decline button text color       | `declineButtonTextColor?: string;`    |
| **declineButtonBackground**   | Used to set decline button background color | `declineButtonBackground?: string;`   |
| **declineButtonBorderRadius** | Used to set decline button border radius    | `declineButtonBorderRadius?: string;` |
| **declineButtonBorder**       | Used to set decline button border           | `declineButtonBorder?: string;`       |

#### 2. Avatar Style

If you want to apply customized styles to the `Avatar` component within the `Incoming Call` Component, you can use the following code snippet. For more information you can refer [Avatar Styles](/ui-kit/react/v4/avatar#avatar-style).

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import {
      CometChatIncomingCall,
      AvatarStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });

      return <CometChatIncomingCall avatarStyle={avatarStyle} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import {
      CometChatIncomingCall,
      AvatarStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });

      return <CometChatIncomingCall avatarStyle={avatarStyle} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

#### 3. ListItem Style

If you want to apply customized styles to the `ListItemStyle` component within the `Incoming Call` Component, you can use the following code snippet. For more information, you can refer [ListItem Styles](/ui-kit/react/v4/list-item#listitemstyle).

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import {
      CometChatIncomingCall,
      ListItemStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid #cdc2ff",
      });

      return <CometChatIncomingCall listItemStyle={listItemStyle} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import {
      CometChatIncomingCall,
      ListItemStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid #cdc2ff",
      });

      return <CometChatIncomingCall listItemStyle={listItemStyle} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

Here is a code snippet demonstrating how you can customize the functionality of the `Incoming Call` component.

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      return (
        <CometChatIncomingCall
          acceptButtonText="Your Custom Accept Button Text"
          declineButtonText="Your Decline Button Text"
          disableSoundForCalls={true}
        />
      );
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      return (
        <CometChatIncomingCall
          acceptButtonText="Your Custom Accept Button Text"
          declineButtonText="Your Decline Button Text"
          disableSoundForCalls={true}
        />
      );
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/iII-209mTdOytBSH/images/f0c6a7bb-incoming_calls_functionality_default_web_screens-fdf7258941671062554458f11e25fe23.png?fit=max&auto=format&n=iII-209mTdOytBSH&q=85&s=cbdf6508f8e0f10c40c6f390147a6e20" width="3600" height="2400" data-path="images/f0c6a7bb-incoming_calls_functionality_default_web_screens-fdf7258941671062554458f11e25fe23.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/D1t_n71f5KROvakA/images/5de55041-incoming_calls_functionality_custom_web_screens-97ae3b613235142bd2dcc178623c99a2.png?fit=max&auto=format&n=D1t_n71f5KROvakA&q=85&s=5a6c28bf1acecacca30162fa6a472086" width="3600" height="2400" data-path="images/5de55041-incoming_calls_functionality_custom_web_screens-97ae3b613235142bd2dcc178623c99a2.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                 | Description                                                                       | Code                                                |
| ------------------------ | --------------------------------------------------------------------------------- | --------------------------------------------------- |
| **acceptButtonText**     | Used to set custom accept button text                                             | `acceptButtonText='Your Custom Accept Button Text'` |
| **declineButtonText**    | Used to set custom decline button text                                            | `declineButtonText='Your Decline Button Text'`      |
| **customSoundForCalls**  | Used to set custom sound for incoming calls                                       | `customSoundForCalls='Your Custom Sound For Calls'` |
| **disableSoundForCalls** | Used to disable/enable the sound of incoming calls, by default it is set to false | `disableSoundForCalls={true}`                       |
| **call**                 | CometChat call object consumed by the component to launch itself                  | `call={callObject}`                                 |

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### SubtitleView

By using the `subtitleView` property, you can modify the SubtitleView to meet your specific needs.

```javascript theme={null}
subtitleView = { getSubtitleView };
```

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/nUllIo1r4Bhce7kY/images/35334601-incoming_call_subtitle_view_default_web_screens-ded0db74060c4d5c494fd4ec1acd713b.png?fit=max&auto=format&n=nUllIo1r4Bhce7kY&q=85&s=48edb162dfcb16a2c837ca1df3fce789" width="3600" height="2400" data-path="images/35334601-incoming_call_subtitle_view_default_web_screens-ded0db74060c4d5c494fd4ec1acd713b.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/oaJbJ0bOxG69pJ1L/images/8b2a3864-incoming_call_subtitle_view_custom_web_screens-523f317886d2e73e76095693ecae8cfb.png?fit=max&auto=format&n=oaJbJ0bOxG69pJ1L&q=85&s=6f2d778f3c90a76271d28aebb97cee64" width="3600" height="2400" data-path="images/8b2a3864-incoming_call_subtitle_view_custom_web_screens-523f317886d2e73e76095693ecae8cfb.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const getSubtitleView = (user: CometChat.User): JSX.Element => {
        function formatTime(timestamp: number) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (user instanceof CometChat.User) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "2px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(user.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };

      return <CometChatIncomingCall subtitleView={getSubtitleView} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      const getSubtitleView = (user) => {
        function formatTime(timestamp) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (user instanceof CometChat.User) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "2px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(user.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };

      return <CometChatIncomingCall subtitleView={getSubtitleView} />;
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

***

## Configuration

Configurations offer the ability to customize the properties of each individual component within a Composite Component.

The Incoming Call Component is a Composite Component and it has a specific set of configuration for each of its components.

### OngoingCall

If you want to customize the properties of the [OngoingCall](/ui-kit/react/v4/ongoing-call) Component inside Incoming Call Component, you need use the `CallScreenConfiguration` object.

The `OngoingCallConfiguration` provides access to all the [Action](/ui-kit/react/v4/ongoing-call#actions), [Filters](/ui-kit/react/v4/ongoing-call#filters), [Styles](/ui-kit/react/v4/ongoing-call#style), [Functionality](/ui-kit/react/v4/ongoing-call#functionality), and [Advanced](/ui-kit/react/v4/ongoing-call#advanced) properties of the [OngoingCall](/ui-kit/react/v4/ongoing-call) component.

<Info>
  Please note that the properties marked with the [report]() symbol are not accessible within the Configuration Object.
</Info>

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bUk-WwSNpBXF92Yc/images/dd41a58c-call_buttons_ongoingcall_configuration-2c6d2cf534b41abb33ef52c6b1925fe5.png?fit=max&auto=format&n=bUk-WwSNpBXF92Yc&q=85&s=61e9929a1bef67d798eba55772fafe2e" width="3597" height="2398" data-path="images/dd41a58c-call_buttons_ongoingcall_configuration-2c6d2cf534b41abb33ef52c6b1925fe5.png" />
</Frame>

In this example, we will show how you can display the call recording button in the [OngoingCall](/ui-kit/react/v4/ongoing-call) component using `ongoingCallConfiguration`.

<Tabs>
  <Tab title="TypeScript">
    IncomingCallsDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatIncomingCall,
      CallScreenConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      function customSettingBuilderForIncoming(call: any) {
        const builder = new CometChatUIKitCalls.CallSettingsBuilder();
        if (call?.getType() == CometChatUIKitConstants.MessageTypes.audio) {
          builder
            .enableDefaultLayout(true)
            .setIsAudioOnlyCall(true)
            .showRecordingButton(true);
        } else if (call?.getType() == CometChatUIKitConstants.MessageTypes.video) {
          builder
            .enableDefaultLayout(true)
            .setIsAudioOnlyCall(false)
            .showRecordingButton(true);
        }
        return builder;
      }
      return (
        <CometChatIncomingCall
          ongoingCallConfiguration={
            new CallScreenConfiguration({
              callSettingsBuilder: customSettingBuilderForIncoming,
            })
          }
        />
      );
    };

    export default IncomingCallsDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    IncomingCallsDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatIncomingCall,
      CallScreenConfiguration,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const IncomingCallsDemo = () => {
      function customSettingBuilderForIncoming(call) {
        const builder = new CometChatUIKitCalls.CallSettingsBuilder();
        if (call?.getType() == CometChatUIKitConstants.MessageTypes.audio) {
          builder
            .enableDefaultLayout(true)
            .setIsAudioOnlyCall(true)
            .showRecordingButton(true);
        } else if (call?.getType() == CometChatUIKitConstants.MessageTypes.video) {
          builder
            .enableDefaultLayout(true)
            .setIsAudioOnlyCall(false)
            .showRecordingButton(true);
        }
        return builder;
      }
      return (
        <CometChatIncomingCall
          ongoingCallConfiguration={
            new CallScreenConfiguration({
              callSettingsBuilder: customSettingBuilderForIncoming,
            })
          }
        />
      );
    };

    export default IncomingCallsDemo;
    ```
  </Tab>
</Tabs>

***


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Incoming Call

> Incoming Call — CometChat documentation.

## Overview

The `Incoming call` is a [Component](/docs/ui-kit/angular/v4/components-overview#components) that serves as a visual representation when the user receives an incoming call, such as a voice call or video call, providing options to answer or decline the call.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_oiGBuX1qG3S8Eo5/images/60c4a77c-incoming_calls_overview_web_screens-d88b7ba55048b0223256329a84362b46.png?fit=max&auto=format&n=_oiGBuX1qG3S8Eo5&q=85&s=e67a3c610f888d78561d0220f3360016" width="3600" height="2400" data-path="images/60c4a77c-incoming_calls_overview_web_screens-d88b7ba55048b0223256329a84362b46.png" />
</Frame>

The `Incoming Call` is comprised of the following base components:

| Components                                          | Description                                                                                                                                    |
| --------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------- |
| [cometchat-list-item](/docs/ui-kit/angular/v4/list-item) | This component’s view consists of avatar, status indicator , title, and subtitle. The fields are then mapped with the SDK’s user, group class. |
| [cometchat-icon](/docs/ui-kit/angular/v4/icon)           | This component displays an icon. It currently supports only svg icons                                                                          |
| [cometchat-label](/docs/ui-kit/angular/v4/label)         | This component provides descriptive information about the associated UI element.                                                               |
| cometchat-button                                    | This component represents a button with optional icon and text.                                                                                |
| [cometchat-avatar](/docs/ui-kit/angular/v4/avatar)       | This component component displays an image or user's avatar with fallback to the first two letters of the username                             |

## Usage

### Integration

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatIncomingCall } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatIncomingCall],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

##### 1. onAccept

`onAccept` is triggered when you click the accept button of the `Incoming Call` component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public handleOnAccept = (call: CometChat.Call) => {
        console.log("your custom on accept actions", call);
      };
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [onAccept]="handleOnAccept"
      ></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

##### 2. onDecline

`onDecline` is triggered when you click the Decline button of the `Incoming Call` component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public handleOnDecline = (call: CometChat.Call) => {
        console.log("your custom on decline action");
      };
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [onDecline]="handleOnDecline"
      ></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

##### 3. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Incoming Call component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public handleOnError = (error: CometChat.CometChatException) => {
        console.log("your custom on error action", error);
      };
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call [onError]="handleOnError"></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a `Component`. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using `RequestBuilders` of Chat SDK.

The `Incoming Call` component does not have any exposed filters.

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The list of events emitted by the Incoming Call component is as follows.

| Event              | Description                                                                  |
| ------------------ | ---------------------------------------------------------------------------- |
| **ccCallRejected** | This event is triggered when the initiated call is rejected by the receiver. |
| **ccCallAccepted** | This event is triggered when the initiated call is accepted by the receiver. |
| **ccCallEnded**    | This event is triggered when the initiated call successfully ends.           |

Adding `CometChatCallEvents` Listener's

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    import {CometChatCallEvents} from "@cometchat/chat-uikit-angular";

    this.ccCallRejected = CometChatCallEvents.ccCallRejected.subscribe(
    (call: CometChat.Call) => {
            // Your Code
      }
    );

    this.ccCallAccepted = CometChatCallEvents.ccCallAccepted.subscribe(
    (call: CometChat.Call) => {
            // Your Code
      }
    );

    this.ccCallEnded = CometChatCallEvents.ccCallEnded.subscribe(
    (call: CometChat.Call) => {
            // Your Code
      }
    );
    ```
  </Tab>
</Tabs>

***

Removing `CometChatCallEvents` Listener's

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    this.ccCallRejected.unsubscribe();
    this.ccCallAccepted.unsubscribe();
    this.ccCallEnded.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Incoming Call component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using Style you can customize the look and feel of the component in your app, These parameters typically control elements such as the color, size, shape, and fonts used within the component.

##### 1. IncomingCall Style

To customize the appearance, you can assign a `IncomingCallStyle` object to the `Incoming Call` component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/79131f41-incoming_calls_style_web_screens-11162dbf1c429ce2670be368246496b2.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=7e1f6c85851839018e2bb6d8c8a39f6f" width="3600" height="2400" data-path="images/79131f41-incoming_calls_style_web_screens-11162dbf1c429ce2670be368246496b2.png" />
</Frame>

**Example**

In this example, we are employing the `IncomingCallStyle`.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { IncomingCallStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      incomingCallStyle = new IncomingCallStyle({
        acceptButtonBackground: "#7b49de",
        acceptButtonTextColor: "#ffffff",
        background: "#8761d4",
        declineButtonBackground: "#4b08d1",
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [incomingCallStyle]="incomingCallStyle"
      ></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

The following properties are exposed by IncomingCallStyle:

| Property                      | Description                                 | Code                                  |
| ----------------------------- | ------------------------------------------- | ------------------------------------- |
| **border**                    | Used to set border                          | `border?: string,`                    |
| **borderRadius**              | Used to set border radius                   | `borderRadius?: string;`              |
| **background**                | Used to set background colour               | `background?: string;`                |
| **height**                    | Used to set height                          | `height?: string;`                    |
| **width**                     | Used to set width                           | `width?: string;`                     |
| **titleTextFont**             | Used to set title text font                 | `titleTextFont?: string,`             |
| **titleTextColor**            | Used to set title text color                | `titleTextColor?: string;`            |
| **subtitleTextFont**          | Used to set subtitle text font              | `subtitleTextFont?: string;`          |
| **subtitleTextColor**         | Used to set subtitle text color             | `subtitleTextColor?: string;`         |
| **acceptButtonTextFont**      | Used to set accept button text font         | `acceptButtonTextFont?: string;`      |
| **acceptButtonTextColor**     | Used to set accept button text color        | `acceptButtonTextColor?: string;`     |
| **acceptButtonBackground**    | Used to set accept button background color  | `acceptButtonBackground?: string;`    |
| **acceptButtonBorderRadius**  | Used to set accept button border radius     | `acceptButtonBorderRadius?: string;`  |
| **acceptButtonBorder**        | Used to set accept button border            | `acceptButtonBorder?: string;`        |
| **declineButtonTextFont**     | Used to set decline button text font        | `declineButtonTextFont?: string;`     |
| **declineButtonTextColor**    | Used to set decline button text color       | `declineButtonTextColor?: string;`    |
| **declineButtonBackground**   | Used to set decline button background color | `declineButtonBackground?: string;`   |
| **declineButtonBorderRadius** | Used to set decline button border radius    | `declineButtonBorderRadius?: string;` |
| **declineButtonBorder**       | Used to set decline button border           | `declineButtonBorder?: string;`       |

##### 2. Avatar Style

If you want to apply customized styles to the `Avatar` component within the `Incoming Call` Component, you can use the following code snippet. For more information you can refer [Avatar Styles](/docs/ui-kit/angular/v4/avatar#avatar-style).

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, AvatarStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff"
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [avatarStyle]="avatarStyle"
      ></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

##### 3. ListItem Style

If you want to apply customized styles to the `List Item` component within the `Incoming Call` Component, you can use the following code snippet. For more information, you can refer [ListItem Styles](/docs/ui-kit/angular/v4/list-item#listitemstyle).

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding: "5px",
        border: "1px solid #e9b8f5",
        titleColor: "#8830f2",
        borderRadius: "20px",
        width: "100% !important"
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [listItemStyle]="listItemStyle"
      ></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

Here is a code snippet demonstrating how you can customize the functionality of the `Incoming Call` component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [acceptButtonText]="'Your Custom Accept Button Text'"
        [declineButtonText]="'Your Decline Button Text'"
        [disableSoundForCalls]="true"
      ></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/iII-209mTdOytBSH/images/f0c6a7bb-incoming_calls_functionality_default_web_screens-fdf7258941671062554458f11e25fe23.png?fit=max&auto=format&n=iII-209mTdOytBSH&q=85&s=cbdf6508f8e0f10c40c6f390147a6e20" width="3600" height="2400" data-path="images/f0c6a7bb-incoming_calls_functionality_default_web_screens-fdf7258941671062554458f11e25fe23.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/D1t_n71f5KROvakA/images/5de55041-incoming_calls_functionality_custom_web_screens-97ae3b613235142bd2dcc178623c99a2.png?fit=max&auto=format&n=D1t_n71f5KROvakA&q=85&s=5a6c28bf1acecacca30162fa6a472086" width="3600" height="2400" data-path="images/5de55041-incoming_calls_functionality_custom_web_screens-97ae3b613235142bd2dcc178623c99a2.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                 | Description                                                                       | Code                                                    |
| ------------------------ | --------------------------------------------------------------------------------- | ------------------------------------------------------- |
| **acceptButtonText**     | Used to set custom accept button text                                             | `[acceptButtonText]="'Your Custom Accept Button Text'"` |
| **declineButtonText**    | Used to set custom decline button text                                            | `[declineButtonText]="'Your Decline Button Text'"`      |
| **customSoundForCalls**  | Used to set custom sound for incoming calls                                       | `[customSoundForCalls]="customSoundForCalls"`           |
| **disableSoundForCalls** | Used to disable/enable the sound of incoming calls, by default it is set to false | `[disableSoundForCalls]="true"`                         |
| **call**                 | CometChat call object consumed by the component to launch itself                  | `[call]="callObject"`                                   |

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### SubtitleView

By using the `subtitleView` property, you can modify the SubtitleView to meet your specific needs.

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/nUllIo1r4Bhce7kY/images/35334601-incoming_call_subtitle_view_default_web_screens-ded0db74060c4d5c494fd4ec1acd713b.png?fit=max&auto=format&n=nUllIo1r4Bhce7kY&q=85&s=48edb162dfcb16a2c837ca1df3fce789" width="3600" height="2400" data-path="images/35334601-incoming_call_subtitle_view_default_web_screens-ded0db74060c4d5c494fd4ec1acd713b.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/oaJbJ0bOxG69pJ1L/images/8b2a3864-incoming_call_subtitle_view_custom_web_screens-523f317886d2e73e76095693ecae8cfb.png?fit=max&auto=format&n=oaJbJ0bOxG69pJ1L&q=85&s=6f2d778f3c90a76271d28aebb97cee64" width="3600" height="2400" data-path="images/8b2a3864-incoming_call_subtitle_view_custom_web_screens-523f317886d2e73e76095693ecae8cfb.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [subtitleView]="subtitleTemplate"
      ></cometchat-incoming-call>
    </div>
    <ng-template #subtitleTemplate>
      <div
        style="display: flex; align-items: left; padding: 10px; font-size: 10px;"
      >
        Your Custom subtitle view
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

## Configuration

Configurations offer the ability to customize the properties of each individual component within a Composite Component.

The Incoming Call Component is a Composite Component and it has a specific set of configuration for each of its components.

### OngoingCall

If you want to customize the properties of the [OngoingCall](/docs/ui-kit/angular/v4/ongoing-call) Component inside Incoming Call Component, you need use the `CallScreenConfiguration` object.

The `OngoingCallConfiguration` provides access to all the [Action](/docs/ui-kit/angular/v4/ongoing-call#actions), [Filters](/docs/ui-kit/angular/v4/ongoing-call#filters), [Styles](/docs/ui-kit/angular/v4/ongoing-call#style), [Functionality](/docs/ui-kit/angular/v4/ongoing-call#functionality), and [Advanced](/docs/ui-kit/angular/v4/ongoing-call#advanced) properties of the [OngoingCall](/docs/ui-kit/angular/v4/ongoing-call) component.

> Please note that the Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bUk-WwSNpBXF92Yc/images/dd41a58c-call_buttons_ongoingcall_configuration-2c6d2cf534b41abb33ef52c6b1925fe5.png?fit=max&auto=format&n=bUk-WwSNpBXF92Yc&q=85&s=61e9929a1bef67d798eba55772fafe2e" width="3597" height="2398" data-path="images/dd41a58c-call_buttons_ongoingcall_configuration-2c6d2cf534b41abb33ef52c6b1925fe5.png" />
</Frame>

In this example, we will show how you can display the call recording button in the [OngoingCall](/docs/ui-kit/angular/v4/ongoing-call) component using `ongoingCallConfiguration`.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, CallScreenConfiguration, CometChatUIKitCalls, CometChatUIKitConstants } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public ongoingCallConfiguration!: CallScreenConfiguration;
      ngOnInit(): void {
        this.ongoingCallConfiguration = new CallScreenConfiguration({
          callSettingsBuilder: this.customSettingBuilderForIncoming
        });
      }
      customSettingBuilderForIncoming(call: any) {
        const builder = new CometChatUIKitCalls.CallSettingsBuilder();
        if (call?.getType() == CometChatUIKitConstants.MessageTypes.audio) {
          builder
            .enableDefaultLayout(true)
            .setIsAudioOnlyCall(true)
            .showRecordingButton(true);
        }
        else if (call?.getType() == CometChatUIKitConstants.MessageTypes.video) {
          builder
            .enableDefaultLayout(true)
            .setIsAudioOnlyCall(false)
            .showRecordingButton(true);
        }
        return builder;
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-incoming-call
        [ongoingCallConfiguration]="ongoingCallConfiguration"
      ></cometchat-incoming-call>
    </div>
    ```
  </Tab>
</Tabs>

***
